Index: installation.sgml
===================================================================
RCS file: /projects/cvsroot/pgsql/doc/src/sgml/installation.sgml,v
retrieving revision 1.299
diff -c -u -r1.299 installation.sgml
--- installation.sgml	24 Jan 2008 06:23:32 -0000	1.299
+++ installation.sgml	31 Jan 2008 16:40:26 -0000
@@ -1808,500 +1808,98 @@
   <title>Supported Platforms</title>
 
   <para>
-   <productname>PostgreSQL</> has been verified by the developer
-   community to work on the platforms listed below. A supported
-   platform generally means that <productname>PostgreSQL</> builds and
-   installs according to these instructions and that the regression
-   tests pass.  <quote>Build farm</quote> entries refer to active test
-   machines in the <ulink url="http://buildfarm.postgresql.org/">
-   PostgreSQL Build Farm</ulink>.
-   Platform entries that show an older version of
-   PostgreSQL are those that did not receive explicit testing at the
-   time of release of version &majorversion; but that we still
-   expect to work.
-  </para>
-
-  <note>
-   <para>
-    If you are having problems with the installation on a supported
-    platform, please write to <email>pgsql-bugs@postgresql.org</email>
-    or <email>pgsql-ports@postgresql.org</email>, not to the people
-    listed here.
-   </para>
-  </note>
 
-    <informaltable>
-     <tgroup cols="5">
-      <thead>
-       <row>
-        <entry><acronym>OS</acronym></entry>
-        <entry>Processor</entry>
-        <entry>Version</entry>
-        <entry>Reported</entry>
-        <entry>Remarks</entry>
-       </row>
-      </thead>
-      <tbody>
-       <row>
-        <entry><systemitem class="osname">AIX</></entry>
-        <entry><systemitem>PowerPC</></entry>
-        <entry>8.2.0</entry>
-        <entry>Build farm
-         <systemitem class="systemname">grebe</systemitem> (5.3, gcc 4.0.1); 
-         <systemitem class="systemname">kookaburra</systemitem> (5.2, cc 6.0); 
-         <systemitem class="systemname">asp</systemitem> (5.2, gcc 3.3.2)</entry>
-        <entry>see <filename>doc/FAQ_AIX</filename>,
-         particularly if using AIX 5.3 ML3</entry>
-       </row>
-       <row>
-        <entry><systemitem class="osname">AIX</></entry>
-        <entry><systemitem>RS6000</></entry>
-        <entry>8.0.0</entry>
-        <entry>Hans-J&uuml;rgen Sch&ouml;nig (<email>hs@cybertec.at</email>), 2004-12-06</entry>
-        <entry>see <filename>doc/FAQ_AIX</filename></entry>
-       </row>
-       <row>
-        <entry><systemitem class="osname">BSD/OS</></entry>
-        <entry><systemitem>x86</></entry>
-        <entry>8.2.0</entry>
-        <entry>Bruce Momjian (<email>bruce@momjian.us</email>), 2007-01-25</entry>
-        <entry>4.3.1</entry>
-       </row>
-       <row>
-        <entry><systemitem class="osname">Debian GNU/Linux</></entry>
-        <entry><systemitem>Alpha</></entry>
-        <entry>8.2.0</entry>
-        <entry>Build farm <systemitem class="systemname">hare</systemitem> (3.1, gcc 3.3.4)</entry>
-        <entry></entry>
-       </row>
-       <row>
-        <entry><systemitem class="osname">Debian GNU/Linux</></entry>
-        <entry><systemitem>AMD64</></entry>
-        <entry>8.2.0</entry>
-        <entry>Build farm
-         <systemitem class="systemname">shad</systemitem> (4.0, gcc 4.1.2);
-         <systemitem class="systemname">kite</systemitem> (3.1, gcc 4.0);
-         <systemitem class="systemname">panda</systemitem> (sid, gcc 3.3.5)</entry>
-        <entry></entry>
-       </row>
-       <row>
-        <entry><systemitem class="osname">Debian GNU/Linux</></entry>
-        <entry><systemitem>ARM</></entry>
-        <entry>8.2.0</entry>
-        <entry>Build farm <systemitem class="systemname">penguin</systemitem> (3.1, gcc 3.3.4)</entry>
-        <entry></entry>
-       </row>
-       <row>
-        <entry><systemitem class="osname">Debian GNU/Linux</></entry>
-        <entry><systemitem>Athlon XP</></entry>
-        <entry>8.2.0</entry>
-        <entry>Build farm <systemitem class="systemname">rook</systemitem> (3.1, gcc 3.3.5)</entry>
-        <entry></entry>
-       </row>
-       <row>
-        <entry><systemitem class="osname">Debian GNU/Linux</></entry>
-        <entry><systemitem>IA64</></entry>
-        <entry>8.2.0</entry>
-        <entry>Build farm <systemitem class="systemname">dugong</systemitem> (unstable, icc 9.1.045)</entry>
-        <entry></entry>
-       </row>
-       <row>
-        <entry><systemitem class="osname">Debian GNU/Linux</></entry>
-        <entry><systemitem>m68k</></entry>
-        <entry>8.0.0</entry>
-        <entry>No&egrave;l K&ouml;the (<email>noel@debian.org</email>), 2004-12-09</entry>
-        <entry>sid</entry>
-       </row>
-       <row>
-        <entry><systemitem class="osname">Debian GNU/Linux</></entry>
-        <entry><systemitem>MIPS</></entry>
-        <entry>8.2.0</entry>
-        <entry>Build farm
-         <systemitem class="systemname">otter</systemitem> (3.1, gcc 3.3.4)</entry>
-        <entry></entry>
-       </row>
-       <row>
-        <entry><systemitem class="osname">Debian GNU/Linux</></entry>
-        <entry><systemitem>MIPSEL</></entry>
-        <entry>8.2.0</entry>
-        <entry>Build farm
-         <systemitem class="systemname">lionfish</systemitem> (3.1, gcc 3.3.4);
-         <systemitem class="systemname">corgi</systemitem> (3.1, gcc 3.3.4)</entry>
-        <entry></entry>
-       </row>
-       <row>
-        <entry><systemitem class="osname">Debian GNU/Linux</></entry>
-        <entry><systemitem>PA-RISC</></entry>
-        <entry>8.2.0</entry>
-        <entry>Build farm
-         <systemitem class="systemname">manatee</systemitem> (3.1, gcc 4.0.1);
-         <systemitem class="systemname">kingfisher</systemitem> (3.1, gcc 3.3.5)</entry>
-        <entry></entry>
-     </row>
-       <row>
-        <entry><systemitem class="osname">Debian GNU/Linux</></entry>
-        <entry><systemitem>PowerPC</></entry>
-        <entry>8.0.0</entry>
-        <entry>No&egrave;l K&ouml;the (<email>noel@debian.org</email>), 2004-12-15</entry>
-        <entry>sid</entry>
-       </row>
-       <row>
-        <entry><systemitem class="osname">Debian GNU/Linux</></entry>
-        <entry><systemitem>Sparc</></entry>
-        <entry>8.1.0</entry>
-        <entry>Build farm <systemitem class="systemname">dormouse</systemitem>
-         (3.1, gcc 3.2.5; 64-bit)</entry>
-        <entry></entry>
-       </row>
-       <row>
-        <entry><systemitem class="osname">Debian GNU/Linux</></entry>
-        <entry><systemitem>x86</></entry>
-        <entry>8.2.0</entry>
-        <entry>Build farm <systemitem class="systemname">wildebeest</systemitem> (3.1, gcc 3.3.5)</entry>
-       </row>
-       <row>
-        <entry><systemitem class="osname">Fedora Linux</></entry>
-        <entry><systemitem>AMD64</></entry>
-        <entry>8.2.0</entry>
-        <entry>Build farm
-         <systemitem class="systemname">impala</systemitem> (FC6, gcc 4.1.1);
-         <systemitem class="systemname">bustard</systemitem> (FC5, gcc 4.1.0);
-         <systemitem class="systemname">wasp</systemitem> (FC5, gcc 4.1.0);
-         <systemitem class="systemname">viper</systemitem> (FC3, gcc 3.4.4)</entry>
-        <entry></entry>
-       </row>
-       <row>
-        <entry><systemitem class="osname">Fedora Linux</></entry>
-        <entry><systemitem>PowerPC</></entry>
-        <entry>8.2.0</entry>
-        <entry>Build farm
-         <systemitem class="systemname">sponge</systemitem> (FC5, gcc 4.1.0)</entry>
-        <entry></entry>
-       </row>
-       <row>
-        <entry><systemitem class="osname">Fedora Linux</></entry>
-        <entry><systemitem>x86</></entry>
-        <entry>8.2.0</entry>
-        <entry>Build farm
-         <systemitem class="systemname">agouti</systemitem> (FC5, gcc 4.1.1);
-         <systemitem class="systemname">thrush</systemitem> (FC1, gcc 3.3.2)</entry>
-        <entry></entry>
-       </row>
-       <row>
-        <entry><systemitem class="osname">FreeBSD</></entry>
-        <entry><systemitem>AMD64</></entry>
-        <entry>8.2.0</entry>
-        <entry>Build farm
-         <systemitem class="systemname">platypus</systemitem> (6, gcc 3.4.4);
-         <systemitem class="systemname">dove</systemitem> (6.1, gcc 3.4.4);
-         <systemitem class="systemname">ermine</systemitem> (6.1, gcc 3.4.4)</entry>
-        <entry></entry>
-       </row>
-       <row>
-        <entry><systemitem class="osname">FreeBSD</></entry>
-        <entry><systemitem>x86</></entry>
-        <entry>8.2.0</entry>
-        <entry>Build farm
-         <systemitem class="systemname">minnow</systemitem> (6.1, gcc 3.4.4);
-         <systemitem class="systemname">echidna</systemitem> (6, gcc 3.4.2);
-         <systemitem class="systemname">herring</systemitem> (6, Intel cc 7.1)</entry>
-        <entry></entry>
-       </row>
-       <row>
-        <entry><systemitem class="osname">Gentoo Linux</></entry>
-        <entry><systemitem>AMD64</></entry>
-        <entry>8.1.0</entry>
-        <entry>Build farm <systemitem class="systemname">caribou</systemitem> (2.6.9, gcc 3.3.5)</entry>
-        <entry></entry>
-       </row>
-       <row>
-        <entry><systemitem class="osname">Gentoo Linux</></entry>
-        <entry><systemitem>IA64</></entry>
-        <entry>8.2.0</entry>
-        <entry>Build farm <systemitem class="systemname">stoat</systemitem> (2.6, gcc 3.3)</entry>
-        <entry></entry>
-       </row>
-       <row>
-        <entry><systemitem class="osname">Gentoo Linux</></entry>
-        <entry><systemitem>PowerPC 64</></entry>
-        <entry>8.2.0</entry>
-        <entry>Build farm <systemitem class="systemname">cobra</systemitem> (1.4.16, gcc 3.4.3)</entry>
-        <entry></entry>
-       </row>
-       <row>
-        <entry><systemitem class="osname">Gentoo Linux</></entry>
-        <entry><systemitem>x86</></entry>
-        <entry>8.2.0</entry>
-        <entry>Build farm <systemitem class="systemname">mongoose</systemitem> (1.6.14, icc 9.0.032)</entry>
-        <entry></entry>
-       </row>
-       <row>
-        <entry><systemitem class="osname">HP-UX</></entry>
-        <entry><systemitem>IA64</></entry>
-        <entry>8.2.0</entry>
-        <entry>Tom Lane (<email>tgl@sss.pgh.pa.us</email>), 2006-10-23</entry>
-        <entry>11.23, <command>gcc</> and <command>cc</>; see <filename>doc/FAQ_HPUX</filename></entry>
-       </row>
-       <row>
-        <entry><systemitem class="osname">HP-UX</></entry>
-        <entry><systemitem>PA-RISC</></entry>
-        <entry>8.2.0</entry>
-        <entry>Tom Lane (<email>tgl@sss.pgh.pa.us</email>), 2006-10-23</entry>
-        <entry>10.20 and 11.23, <command>gcc</> and <command>cc</>; see <filename>doc/FAQ_HPUX</filename></entry>
-       </row>
-       <row>
-        <entry><systemitem class="osname">IRIX</></entry>
-        <entry><systemitem>MIPS</></entry>
-        <entry>8.1.0</entry>
-        <entry>Kenneth Marshall (<email>ktm@is.rice.edu</email>), 2005-11-04</entry>
-        <entry>6.5, <command>cc</command> only</entry>
-       </row>
-       <row>
-        <entry><systemitem class="osname">Kubuntu Linux</></entry>
-        <entry><systemitem>AMD64</></entry>
-        <entry>8.2.0</entry>
-        <entry>Build farm <systemitem class="systemname">rosella</systemitem> (5.10 <quote>Breezy</>, gcc 4.0)</entry>
-        <entry></entry>
-       </row>
-       <row>
-        <entry><systemitem class="osname">Mac OS X</></entry>
-        <entry><systemitem>PowerPC</></entry>
-        <entry>8.2.0</entry>
-        <entry>Build farm
-         <systemitem class="systemname">tuna</systemitem> (10.4.2, gcc 4.0)</entry>
-        <entry></entry>
-       </row>
-       <row>
-        <entry><systemitem class="osname">Mac OS X</></entry>
-        <entry><systemitem>x86</></entry>
-        <entry>8.2.0</entry>
-        <entry>Build farm
-         <systemitem class="systemname">jackal</systemitem> (10.4.8, gcc 4.0.1)</entry>
-        <entry></entry>
-       </row>
-       <row>
-        <entry><systemitem class="osname">Mandriva Linux</></entry>
-        <entry><systemitem>x86</></entry>
-        <entry>8.2.0</entry>
-        <entry>Build farm <systemitem class="systemname">gopher</systemitem> (Mandriva 2006, gcc 4.0.1)</entry>
-        <entry></entry>
-       </row>
-       <row>
-        <entry><systemitem class="osname">NetBSD</></entry>
-        <entry><systemitem>m68k</></entry>
-        <entry>8.2.0</entry>
-        <entry>Build farm <systemitem class="systemname">osprey</systemitem> (2.0, gcc 3.3.3)</entry>
-        <entry></entry>
-       </row>
-       <row>
-        <entry><systemitem class="osname">NetBSD</></entry>
-        <entry><systemitem>x86</></entry>
-        <entry>8.2.0</entry>
-        <entry>Build farm
-         <systemitem class="systemname">gazelle</systemitem> (3.0, gcc 3.3.3);
-         <systemitem class="systemname">canary</systemitem> (1.6, gcc 2.95.3)</entry>
-       </row>
-       <row>
-        <entry><systemitem class="osname">OpenBSD</></entry>
-        <entry><systemitem>AMD64</></entry>
-        <entry>8.2.0</entry>
-        <entry>Build farm
-         <systemitem class="systemname">zebra</systemitem> (4.0, gcc 3.3.5)</entry>
-       </row>
-       <row>
-        <entry><systemitem class="osname">OpenBSD</></entry>
-        <entry><systemitem>Sparc</></entry>
-        <entry>8.0.0</entry>
-        <entry>Chris Mair (<email>list@1006.org</email>), 2005-01-10</entry>
-        <entry>3.3</entry>
-       </row>
-       <row>
-        <entry><systemitem class="osname">OpenBSD</></entry>
-        <entry><systemitem>Sparc64</></entry>
-        <entry>8.2.0</entry>
-        <entry>Build farm <systemitem class="systemname">spoonbill</systemitem> (3.9, gcc 3.3.5)</entry>
-       </row>
-       <row>
-        <entry><systemitem class="osname">OpenBSD</></entry>
-        <entry><systemitem>x86</></entry>
-        <entry>8.2.0</entry>
-        <entry>Build farm
-         <systemitem class="systemname">emu</systemitem> (4.0, gcc 3.3.5);
-         <systemitem class="systemname">guppy</systemitem> (3.8, gcc 3.3.5)</entry>
-        <entry>minor ecpg test failure on 3.8</entry>
-       </row>
-       <row>
-        <entry><systemitem class="osname">Red Hat Linux</></entry>
-        <entry><systemitem>AMD64</></entry>
-        <entry>8.1.0</entry>
-        <entry>Tom Lane (<email>tgl@sss.pgh.pa.us</email>), 2005-10-23</entry>
-        <entry>RHEL 4</entry>
-       </row>
-       <row>
-        <entry><systemitem class="osname">Red Hat Linux</></entry>
-        <entry><systemitem>IA64</></entry>
-        <entry>8.1.0</entry>
-        <entry>Tom Lane (<email>tgl@sss.pgh.pa.us</email>), 2005-10-23</entry>
-        <entry>RHEL 4</entry>
-       </row>
-       <row>
-        <entry><systemitem class="osname">Red Hat Linux</></entry>
-        <entry><systemitem>PowerPC</></entry>
-        <entry>8.1.0</entry>
-        <entry>Tom Lane (<email>tgl@sss.pgh.pa.us</email>), 2005-10-23</entry>
-        <entry>RHEL 4</entry>
-       </row>
-       <row>
-        <entry><systemitem class="osname">Red Hat Linux</></entry>
-        <entry><systemitem>PowerPC 64</></entry>
-        <entry>8.1.0</entry>
-        <entry>Tom Lane (<email>tgl@sss.pgh.pa.us</email>), 2005-10-23</entry>
-        <entry>RHEL 4</entry>
-       </row>
-       <row>
-        <entry><systemitem class="osname">Red Hat Linux</></entry>
-        <entry><systemitem>S/390</></entry>
-        <entry>8.1.0</entry>
-        <entry>Tom Lane (<email>tgl@sss.pgh.pa.us</email>), 2005-10-23</entry>
-        <entry>RHEL 4</entry>
-       </row>
-       <row>
-        <entry><systemitem class="osname">Red Hat Linux</></entry>
-        <entry><systemitem>S/390x</></entry>
-        <entry>8.1.0</entry>
-        <entry>Tom Lane (<email>tgl@sss.pgh.pa.us</email>), 2005-10-23</entry>
-        <entry>RHEL 4</entry>
-       </row>
-       <row>
-        <entry><systemitem class="osname">Red Hat Linux</></entry>
-        <entry><systemitem>x86</></entry>
-        <entry>8.1.0</entry>
-        <entry>Tom Lane (<email>tgl@sss.pgh.pa.us</email>), 2005-10-23</entry>
-        <entry>RHEL 4</entry>
-       </row>
-       <row>
-        <entry><systemitem class="osname">Slackware Linux</></entry>
-        <entry><systemitem>x86</></entry>
-        <entry>8.1.0</entry>
-        <entry>Sergey Koposov (<email>math@sai.msu.ru</email>), 2005-10-24</entry>
-        <entry>10.0</entry>
-       </row>
-       <row>
-        <entry><systemitem class="osname">Solaris</></entry>
-        <entry><systemitem>Sparc</></entry>
-        <entry>8.2.0</entry>
-        <entry>Build farm
-         <systemitem class="systemname">hyena</systemitem> (Solaris 10, gcc 3.4.3)</entry>
-        <entry>see <filename>doc/FAQ_Solaris</filename></entry>
-       </row>
-       <row>
-        <entry><systemitem class="osname">Solaris</></entry>
-        <entry><systemitem>x86</></entry>
-        <entry>8.2.0</entry>
-        <entry>Build farm
-         <systemitem class="systemname">dragonfly</systemitem> (Solaris 9, gcc 3.2.3);
-         <systemitem class="systemname">kudu</systemitem> (Solaris 9, cc 5.3)</entry>
-        <entry>see <filename>doc/FAQ_Solaris</filename></entry>
-       </row>
-       <row>
-        <entry><systemitem class="osname">SUSE Linux</></entry>
-        <entry><systemitem>AMD64</></entry>
-        <entry>8.1.0</entry>
-        <entry>Josh Berkus (<email>josh@agliodbs.com</email>), 2005-10-23</entry>
-        <entry>SLES 9.3</entry>
-       </row>
-       <row>
-        <entry><systemitem class="osname">SUSE Linux</></entry>
-        <entry><systemitem>IA64</></entry>
-        <entry>8.0.0</entry>
-        <entry>Reinhard Max (<email>max@suse.de</email>), 2005-01-03</entry>
-        <entry>SLES 9</entry>
-       </row>
-       <row>
-        <entry><systemitem class="osname">SUSE Linux</></entry>
-        <entry><systemitem>PowerPC</></entry>
-        <entry>8.0.0</entry>
-        <entry>Reinhard Max (<email>max@suse.de</email>), 2005-01-03</entry>
-        <entry>SLES 9</entry>
-       </row>
-       <row>
-        <entry><systemitem class="osname">SUSE Linux</></entry>
-        <entry><systemitem>PowerPC 64</></entry>
-        <entry>8.0.0</entry>
-        <entry>Reinhard Max (<email>max@suse.de</email>), 2005-01-03</entry>
-        <entry>SLES 9</entry>
-       </row>
-       <row>
-        <entry><systemitem class="osname">SUSE Linux</></entry>
-        <entry><systemitem>S/390</></entry>
-        <entry>8.0.0</entry>
-        <entry>Reinhard Max (<email>max@suse.de</email>), 2005-01-03</entry>
-        <entry>SLES 9</entry>
-       </row>
-       <row>
-        <entry><systemitem class="osname">SUSE Linux</></entry>
-        <entry><systemitem>S/390x</></entry>
-        <entry>8.0.0</entry>
-        <entry>Reinhard Max (<email>max@suse.de</email>), 2005-01-03</entry>
-        <entry>SLES 9</entry>
-       </row>
-       <row>
-        <entry><systemitem class="osname">SUSE Linux</></entry>
-        <entry><systemitem>x86</></entry>
-        <entry>8.0.0</entry>
-        <entry>Reinhard Max (<email>max@suse.de</email>), 2005-01-03</entry>
-        <entry>9.0, 9.1, 9.2, SLES 9</entry>
-       </row>
-       <row>
-        <entry><systemitem class="osname">Tru64 UNIX</></entry>
-        <entry><systemitem>Alpha</></entry>
-        <entry>8.1.0</entry>
-        <entry>Honda Shigehiro (<email>fwif0083@mb.infoweb.ne.jp</email>), 2005-11-01</entry>
-        <entry>5.0, <command>cc</> 6.1-011</entry>
-       </row>
-       <row>
-        <entry><systemitem class="osname">Ubuntu Linux</></entry>
-        <entry><systemitem>x86</></entry>
-        <entry>8.2.0</entry>
-        <entry>Build farm <systemitem class="systemname">caracara</systemitem> (6.06, gcc 4.0.3)</entry>
-       </row>
-       <row>
-        <entry><systemitem class="osname">UnixWare</></entry>
-        <entry><systemitem>x86</></entry>
-        <entry>8.2.0</entry>
-        <entry>Build farm <systemitem class="systemname">warthog</systemitem>
-         (7.1.4, <command>cc</command> 4.2)</entry>
-        <entry>see <filename>doc/FAQ_SCO</filename></entry>
-       </row>
-       <row>
-        <entry><systemitem class="osname">Windows</></entry>
-        <entry><systemitem>x86</></entry>
-        <entry>8.2.0</entry>
-        <entry>Build farm
-         <systemitem class="systemname">yak</systemitem> (XP SP2, gcc 3.4.2);
-         <systemitem class="systemname">bandicoot</systemitem> (Windows 2000 Pro, gcc 3.4.2);
-         <systemitem class="systemname">snake</systemitem> (Windows Server 2003 SP1, gcc 3.4.2);
-         <systemitem class="systemname">trout</systemitem> (Windows Server 2000 SP4, gcc 3.4.2)</entry>
-        <entry>see <filename>doc/FAQ_MINGW</filename></entry>
-       </row>
-       <row>
-        <entry><systemitem class="osname">Windows with <application>Cygwin</application></></entry>
-        <entry><systemitem>x86</></entry>
-        <entry>8.2.0</entry>
-        <entry>Build farm <systemitem class="systemname">eel</systemitem>
-         (W2K Server SP4, gcc 3.4.4)</entry>
-        <entry>see <filename>doc/FAQ_CYGWIN</filename></entry>
-       </row>
-       <row>
-        <entry><systemitem class="osname">Yellow Dog Linux</></entry>
-        <entry><systemitem>PowerPC</></entry>
-        <entry>8.1.0</entry>
-        <entry>Build farm <systemitem class="systemname">carp</systemitem> (4.0, gcc 3.3.3)</entry>
-        <entry></entry>
-       </row>
-      </tbody>
-     </tgroup>
-    </informaltable>
+   <productname>PostgreSQL</> has been verified by the developer
+   community to work on the platforms listed below, based on the
+   presence of a preponderance of recent successful builds of the HEAD
+   branch during development of version 8.3 by active test machines in
+   the <ulink url="http://buildfarm.postgresql.org/"> PostgreSQL Build
+   Farm</ulink>.  Successful buildfarm reports indicate that:</para>
+
+  <itemizedlist>
+   <listitem><para> <productname>PostgreSQL</> along with <filename>contrib</filename> modules were successfully built and installed. </para> </listitem>
+   <listitem><para> Regression tests that are part of the <productname>PostgreSQL</> build ran successfully. </para> </listitem>
+   <listitem><para> Regression tests that are part of the <productname>PostgreSQL</> <filename>contrib</filename> ran successfully. </para> </listitem>
+  </itemizedlist>
+
+<informaltable>
+<tgroup cols="2">
+<thead>
+<row>
+<entry><acronym>OS</acronym>, Compiler, Processor</entry>
+<entry>Build farm node</entry>
+</row>
+</thead>
+<tbody>
+
+<row><entry>AIX 5.3 GCC 4.0.1 PPC</entry> <entry>grebe</entry></row>
+<row><entry>CentOS 5 gcc 4.1.1 Athlon MP</entry> <entry>centaur</entry></row>
+<row><entry>CentOS 5 gcc 4.1.1 Athlon XP 1900</entry> <entry>jaguar</entry></row>
+<row><entry>CentOS Linux 4.4 gcc 3.4.6 i386</entry> <entry>cardinal</entry></row>
+<row><entry>Cygwin/XP-Pro 1.5.24 gcc 3.4.4 i386</entry> <entry>brown_bat</entry></row>
+<row><entry>Debian 3.1 gcc 4.0 x86-64</entry> <entry>kite</entry></row>
+<row><entry>Debian 4.0 gcc 4.1.2 armv5tel</entry> <entry>quagga</entry></row>
+<row><entry>Debian Etch 4 gcc 4.1.2 alpha</entry> <entry>archeopteryx</entry></row>
+<row><entry>Debian Etch icc 10.0.026 ia64</entry> <entry>dugong</entry></row>
+<row><entry>Debian debian 4.0 gcc gcc 4.1.2 Pentium III</entry> <entry>wildebeest</entry></row>
+<row><entry>Debian/Linux 4.0 (Etch) GCC 4.1.2 (Debian 4.1.1-21) i686</entry> <entry>auk</entry></row>
+<row><entry>Debian/VMWare 4.0 (Etch) gcc 4.1.2-pre x86</entry> <entry>raiju</entry></row>
+<row><entry>Fedora 7 gcc 4.1.2 i686</entry> <entry>bobcat</entry></row>
+<row><entry>Fedora Core 3 gcc 3.4.4 x86_64</entry> <entry>viper</entry></row>
+<row><entry>Fedora Core 6 GCC 4.1.2 x86_64</entry> <entry>beaver</entry></row>
+<row><entry>Fedora Core 6 gcc 4.1.1 x86_64</entry> <entry>dungbeetle</entry></row>
+<row><entry>FreeBSD 6.0 gcc 3.4.4 amd64</entry> <entry>tapir</entry></row>
+<row><entry>FreeBSD 6.0-STABLE #5 gcc 3.4.4 amd64</entry> <entry>platypus</entry></row>
+<row><entry>FreeBSD FreeBSD 6.2-RELEASE gcc 3.4.6 [FreeBSD] emt64 (amd64)</entry> <entry>ermine</entry></row>
+<row><entry>Gentoo 1.12.9 gcc 4.1.1 ppc64 PPC970MP</entry> <entry>wombat</entry></row>
+<row><entry>Gentoo 1.6.14 icc 9.0.032 i686</entry> <entry>mongoose</entry></row>
+<row><entry>Gentoo 2007.0 gcc 4.2.2 AMD64</entry> <entry>chinchilla</entry></row>
+<row><entry>Kubuntu "Breezy" 5.10 gcc 4.0 AMD64</entry> <entry>rosella</entry></row>
+<row><entry>Mac OS X 10.4.8 gcc 4.0.1 Intel</entry> <entry>jackal</entry></row>
+<row><entry>Mac OS X 10.4.8 gcc gcc 4.0.0 20041026 PowerPC G4</entry> <entry>cuckoo</entry></row>
+<row><entry>NetBSD 1.6 gcc 2.95.3 x86</entry> <entry>canary</entry></row>
+<row><entry>NetBSD 2.0 gcc 3.3.3 m68k</entry> <entry>osprey</entry></row>
+<row><entry>NetBSD 3.1 gcc 3.3.3 x86</entry> <entry>salamander</entry></row>
+<row><entry>OS X 10.4.8 gcc gcc version 4.0.1 (Apple Computer, Inc. build 5363) Intel</entry> <entry>aubrac</entry></row>
+<row><entry>OpenBSD 3.9 gcc 3.3.5 Sparc64</entry> <entry>spoonbill</entry></row>
+<row><entry>OpenBSD 4.0 gcc 3.3.5 AMD64</entry> <entry>zebra</entry></row>
+<row><entry>Solaris 10 SUN Studio 11 sparc</entry> <entry>winter_moth</entry></row>
+<row><entry>Solaris 10 SUN Studio 11 x86_64</entry> <entry>ghost_moth</entry></row>
+<row><entry>Solaris 10 gcc 3.4.2 x86_64</entry> <entry>emperor_moth</entry></row>
+<row><entry>Solaris 11 SUN Studio 11 sparc</entry> <entry>dot_moth</entry></row>
+<row><entry>Solaris 11 SUN Studio 11 x86_64</entry> <entry>codlin_moth</entry></row>
+<row><entry>Solaris 11 gcc 3.4.3 x86_64</entry> <entry>luna_moth</entry></row>
+<row><entry>Solaris 8 SUN Studio 8 sparc</entry> <entry>gypsy_moth</entry></row>
+<row><entry>Solaris 9 SUN Studio 11 sparc</entry> <entry>turnip_moth</entry></row>
+<row><entry>Solaris 9 Sun WorkShop 6 update 2 C 5.3 x86</entry> <entry>kudu</entry></row>
+<row><entry>Solaris 9 gcc 3.2.3 x86</entry> <entry>dragonfly</entry></row>
+<row><entry>SuSE Enterprise Linux 10 gcc 4.1.1 x86_64</entry> <entry>boodie</entry></row>
+<row><entry>Tru64 5.0 cc V6.1-011 alpha</entry> <entry>bear</entry></row>
+<row><entry>Ubuntu 6.06 GCC 4.0.3 IA-32</entry> <entry>caracara</entry></row>
+<row><entry>Ubuntu 7.10 gcc 4.1.3 x86_64</entry>  <entry/heron/ </row>
+<row><entry>Ubuntu Ubuntu 7.10 gcc gcc 4.1.3 i686</entry> <entry>cougar</entry></row>
+<row><entry>UnixWare 7.1.4 cc 4.2 isa</entry> <entry>warthog</entry></row>
+<row><entry>Vista Ultimate 6.0.6000 MSVC 2005 Pro 8.0.50727.867 x86</entry> <entry>baiji</entry></row>
+<row><entry>Windows Server 2003 R2 5.2.3790 GCC 3.4.2 (mingw-special) i686</entry> <entry>narwhal</entry></row>
+<row><entry>Windows Server 2003 R2 5.2.3790 MSVC 2005 Express 8.0.50727.42 x86</entry> <entry>mastodon</entry></row>
+<row><entry>Windows Vista Ultimate 6.0.6000 GCC 3.4.2 (mingw-special) i686</entry> <entry>vaquita</entry></row>
+<row><entry>Windows XP SP2 Visual C++ 14.00.50727.762 x64</entry> <entry>skylark</entry></row>
+<row><entry>Windows XP SP2 gcc 3.4.2 x86</entry> <entry>yak</entry></row>
+<row><entry>Windows XP-PRO SP2 MSVC++ 2005 Express i686</entry> <entry>red_bat</entry></row>
+<row><entry>Windows XP-Pro SP2 gcc 3.4.2 i386</entry> <entry>dawn_bat</entry></row>
+
+</tbody>
+</tgroup>
+</informaltable>
+
+<note><para> In past versions, there used to be a process where build
+results would be reported in by individual users to construct this
+list of supported versions.  We are now harnessing the popular
+<quote>Build Farm</quote> as a reporting mechanism.  If your preferred
+platform is not included in the build farm, that does not imply that
+<productname>PostgreSQL</> will not work there, but rather that that
+no one has volunteered to operate a node for that
+platform.</para></note>
 
   <formalpara>
    <title>Unsupported Platforms:</title>
@@ -2405,6 +2003,15 @@
     </tbody>
    </tgroup>
   </informaltable>
+  <note>
+   <para>
+    If you are having problems with the installation on a supported
+    platform, please write to <email>pgsql-bugs@postgresql.org</email>
+    or <email>pgsql-ports@postgresql.org</email>, not to the people
+    listed here.
+   </para>
+  </note>
+
  </sect1>
 
 </chapter>